import argparse

from recbole.quick_start import run_recbole


if __name__ == '__main__':
    parser = argparse.ArgumentParser()
    parser.add_argument('--model', '-m', type=str, default='DuoRec', help='name of models')
    # parser.add_argument('--dataset', '-d', type=str, default='ml-100k', help='name of datasets')
    parser.add_argument('--dataset', '-d', type=str, default='Amazon_Beauty', help='name of datasets')
    parser.add_argument('--config_files', type=str, default='seq.yaml', help='config files')

    args, _ = parser.parse_known_args()

    # ['seq.yaml']
    config_file_list = args.config_files.strip().split(' ') if args.config_files else None
    # 注意这里，parser里面的参数都转进这里来了
    run_recbole(model=args.model, dataset=args.dataset, config_file_list=config_file_list)
